#include <stdio.h>
#include <string.h>
#include <stdlib.h>




int ACGT2int[85] = {
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,0,
    0,0,0,0,3
};

int maxPolymer(char *seq){
   int count[4];
   int max;
 
   memset(count,0,sizeof(count));
   for(int i=0;seq[i];i++){
     count[ACGT2int[(int)seq[i]]]++;
   }
   max = count[0];
   for(int i=1;i<4;i++)
     if(count[i]>max)
        max = count[i];
  return max;

}

int main(int argc, char *argv[]){
   char line[1000];
   double ratio;




   if(argc !=2){
     printf("filterPolymer  polymerRatio.\n");
     return 0;
   }
   ratio = 0.7; // efault
   ratio = atof(argv[1]);
   while(fgets(line,sizeof(line)-1,stdin)!=NULL){
      if(line[0]=='>')
        continue;
      strtok(line,"\n");
      if(maxPolymer(line) < strlen(line)*ratio)
         printf(">\n%s\n",line);

   }  
   return 0;
}
