#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int main(int argc, char* argv[]){
 //  FILE *fptr;
   char line[1000],header[1000],qseq[1000],seq[1000],bak,bakq;
   int i,len5,len3,kmer,shift;
   if(argc !=4&& argc !=5 ){
     printf("trim  5'len 3'len [kmer] [shift].\n");
     return 0;
    }

   if(argc >2 ){
     kmer = atoi(argv[3]);
     shift = atoi(argv[4]);
   }else{
     kmer = 0;
     shift = 0;
   }
   len5 = atoi(argv[1]);
   len3 = atoi(argv[2]);
 //  fptr = fopen(argv[1],"r");


   while(fgets(line,sizeof(line)-1,stdin)!=NULL){
     strtok(line,"\n");
     if(line[0]=='>'){   //fasta format
       fgets(seq,sizeof(seq)-1,stdin);
       strtok(seq,"\n");
       if( (int)strlen(seq)-len5-len3 < kmer)
          continue;      
       for(i=len5;i+kmer <=strlen(seq)-len3;i+=shift){
         bak = seq[i+kmer];
         seq[i+kmer]='\0';
         printf("%s\n%s\n",line,seq+i);
         seq[i+kmer] = bak;
         if(shift ==0)
           break;
       }
       if(shift && i-shift < strlen(seq)-len3-kmer)
          printf("%s\n%s\n",line,seq+strlen(seq)-len3-kmer);

     }else if(line[0]=='@'){
       fgets(seq,sizeof(line)-1,stdin);
       strtok(seq,"\n");
       fgets(header,sizeof(line)-1,stdin);
       strtok(header,"\n");
       fgets(qseq,sizeof(line)-1,stdin);
       strtok(qseq,"\n");
       if( (int)strlen(seq)-len5-len3<kmer)
          continue;
       for(i=len5;i+kmer <=strlen(seq)-len3;i+=shift){
         bak = seq[i+kmer];
         seq[i+kmer]='\0';
         bakq = qseq[i+kmer];
         qseq[i+kmer]='\0';
//         seq[strlen(seq)-len3]='\0';
//         qseq[strlen(qseq)-len3]='\0';
         printf("%s\n%s\n%s\n%s\n",line,seq+i,header,qseq+i);             
         seq[i+kmer] = bak;
         qseq[i+kmer] = bakq;
         if(shift==0)
           break;
       }
       if(shift && i-shift < strlen(seq)-len3-kmer)
          printf("%s\n%s\n",line,seq+strlen(seq)-len3-kmer);

     }else{
          printf("Unknow format.\n");
          return 0;
  
        }
   }
//   fclose(fptr);
   return 0;
}

